--------------------------------------------------------------------------
-- LAB 03: example - generic counter 
-- Top module
--------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity top is
    port ( CLK100MHZ: in  std_logic;
           BTNC:      in  std_logic;
           SW_0:      in  std_logic;
           SW_1:      in  std_logic;
           LED:       out signed (3 downto 0));
end top;

architecture Behavioral of top is
    
    constant f_clk_sys: integer := 100e6; -- 100 MHz = 1e8; for simulation use e.g. 4 Hz
    constant f_clk:     integer := 1; -- 1 Hz
    constant cnt_width: integer := 4;
    constant pr_width:  integer := 27;
    constant pr_limit:  integer := f_clk_sys / f_clk - 1;
    
    signal ce: std_logic := '0';

    component counter is
        generic (width: integer := 4);
        port (
            clock:        in  std_logic;
            reset:        in  std_logic;
            clock_enable: in  std_logic;
            count_up:     in  std_logic;
            count_down:   in  std_logic;
            value:        out signed (width-1 downto 0));
    end component;
    
    component prescaler is
        generic (width : integer := 27);
        port (
            clock:         in  std_logic;
            reset:         in  std_logic;
            limit:         in  integer;
            clock_enable:  out std_logic);
    end component;
    
begin
    -- Instantiation
    pr: prescaler 
    generic map (width => pr_width)
    port map (
        clock        => CLK100MHZ,
        reset        => BTNC,
        clock_enable => ce,
        limit        => pr_limit
    );
    
    cnt: counter 
    generic map (width => cnt_width)
    port map (
        clock        => CLK100MHZ,
        reset        => BTNC,
        clock_enable => ce,
        count_up     => SW_0,
        count_down   => SW_1,
        value        => LED
    );
end Behavioral;
